<obituary-image>
  <style>
    .obituary-image {
      width: 150px;
      height: 150px;
      text-align: center;
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center center;
    }

    .thumbnail {
      width: 150px;
      height: 150px;
      margin: auto;
    }

  </style>

  <div class="image-input-group text-center">
    <input id={ imageType.id } type="hidden" name={ imageType.name } value={ imageType.value }>
    <input id={ image.id } type="hidden" name={ image.name } value={ image.value }>
    <div class="text-center">
      <label>{ image.label }</label>
    </div>
    <div class="thumbnail">
      <div class="thumb">
        <div class="obituary-image mb-2" style={ image.url ? 'background-image: url(' + image.url + ')' : ''}></div>
          <div class={ image.value ? 'float-left' : '' }>
            <button type="button" class="btn btn-primary btn-sm mb-2 mb-lg-0" onclick={ openFilePicker }>{ image.value ? config.editButtonLabel : config.setButtonLabel }</button>
          </div>
          <div class="float-right">
            <button if={ image.value } type="button" class="btn btn-danger btn-sm mb-2 mb-lg-0" onclick={ remove }>{ config.removeButtonLabel }</button>
          </div>
      </div>
    </div>
    <br><br>
    <div class="help-block"></div>
  </div>

  <input ref="obituary_image_file_picker" id="obituary-image-file-picker" type="file" style="display: none;">

  <script>
    let self = this;

    this.pickerConfig = this.opts.pickerconfig;
    this.config = this.opts.pickerconfig;

    this.errorMessageSize = this.config.errorMessageSize;
    this.errorMessageFormat = this.config.errorMessageFormat;

    this.image = this.pickerConfig.image;
    this.imageType = this.pickerConfig.imageType;
    this.form = this.pickerConfig.form;

    this.modal = MainApp.modal;
    this.imageCropModal = undefined;
    this.api = MainApp.obituaryManager.api;
    this.alert = MainApp.alert;

    this.on('mount', () => {
      this.initFilePickerInput();
      this.initImageCroppedEventListener();
    });

    remove() {
      this.image.url = '/img/obituary/placeholder_150.png';
      this.image.value = null;

      this.parent.parent.obituary.image_path = undefined;
      this.parent.parent.obituary.image_type = undefined;

      this.parent.parent.update();
    }

    isValidFile(file) {
      if (file.size > 5242880) {
        this.alert.error(this.config.errorMessageSize);
        return false;
      }

      if (file.type !== 'image/jpg' && file.type !== 'image/jpeg' && file.type !== 'image/png') {
        this.alert.error(this.config.errorMessageFormat);
        return false;
      }

      return true;
    }

    initFilePickerInput() {
      let filePickerInput = $(this.root);

      filePickerInput.change(function(e) {
        if (e.target.files && e.target.files[0]) {
          const file = e.target.files[0];

          if (!self.isValidFile(file)) {
            return;
          }

          let reader = new FileReader();
          reader.onload = function(ev) {
            self.openObituaryImageCropperModal(ev.target.result, file, self.config.saveLabel, self.config.savingLabel);
          };
          reader.readAsDataURL(file);
        }
      });
    }

    openObituaryImageCropperModal(image, file, saveLabel, savingLabel) {
      this.imageCropModal = this.modal.openSmall(`<obituary-image-cropper image=${image} file=${file} saveLabel=${saveLabel} savingLabel=${savingLabel}></obituary-image-cropper>`, $.extend({showCloseButton: true, overlayClosesOnClick: false}, {}, {riotElements: ['obituary-image-cropper']}));
    }

    openFilePicker() {
      let filePickerInput = $(this.root);
      filePickerInput.find('#obituary-image-file-picker').click();
    }

    initImageCroppedEventListener() {
      document.addEventListener('image-uploaded', function(e) {
        self.imageCropModal.close();
        const imageDetails = e.detail.image;
        self.image.url = imageDetails.url;
        self.image.value = imageDetails.path;
        self.imageType.value = imageDetails.type;

        self.parent.parent.obituary.image_path = self.image.value;
        self.parent.parent.obituary.image_type = self.imageType.value;

        self.parent.parent.update();
      });
    }
  </script>
</obituary-image>
